// Ciclu hamiltonian de cost minim
#include <fstream>
#include <vector>
#include <algorithm>
using namespace std;

ifstream fin("hamilton.in");
ofstream fout("hamilton.out");

const int MAX_S = 1 << 18, MAX_N = 19, INF = 0x3f3f3f3f;
int C[MAX_S][MAX_N];  // C[i][j] costul minim al unui lant elementar care pleaca din 0 si se termina cu j 
                      // si contine o submultime de noduri memorate in masca i
typedef vector<int> VI;
VI G[MAX_N];
int w[MAX_N][MAX_N]; // costul muchiilor
int n, m;            // noduri, muchii

void CitesteGraf();
void CicluHamiltCostMin();

int main()
{
    CitesteGraf();
	CicluHamiltCostMin();
	
    return 0;
}

void CicluHamiltCostMin()
{
	for (int mask = 0; mask < 1 << n; ++mask)
		for (int x = 0; x < n; ++x)
			C[mask][x] = INF;
	
	// consider 0 nodul de plecare		
    C[1][0] = 0;  // masca 1 contine numai nodul 0
    for (int i = 0; i < 1 << n; ++i)       // pt fiecare subm de noduri memorata in masca i
		for (int j = 0; j < n; ++j)        // pt fiecare nod j
			if ( i & (1 << j) )            // daca nodul j se gaseste in submultimea i
				for (const int& k : G[j])  // pt fiecare vecin k al lui j
					if ( !(i & (1 << k)) ) // daca k nu este in subm i
						C[i | (1 << k)][k] = min(C[i | (1 << k)][k], C[i][j] + w[j][k]);
    
    int res = INF;
    for (int j = 0; j < n; ++j)
		res = min(res, C[(1 << n) - 1][j] + w[j][0]); 
    
    if ( res < INF )
		fout << res << '\n';
	else
		fout << "Nu exista solutie\n";
}

void CitesteGraf()
{
	fin >> n >> m;	
    for (int x = 0; x < n; ++x)
		for (int y = 0; y < n; ++y)
			w[x][y] = INF;
	int x, y, cost;
	
	for (int i = 0; i < m; ++i)
	{
		fin >> x >> y >> cost;
		G[x].push_back(y);
		w[x][y] = cost;
	}
	fin.close();
}
