#include <fstream>
#include <vector>
using namespace std;

ifstream fin("hamilton.in");
ofstream fout("hamilton.out");
 
const int MAX_N = 20, MAX_S = 1 << 18, INF = 1e8;
 
int n, m, res;
int C[MAX_S][MAX_N]; // C[i][j] costul minim al unui lant elementar care pleaca din 0 si se termina cu j
                     // si contine o submultime de noduri memorate in masca i
vector<int> G[MAX_N];
int w[MAX_N][MAX_N]; // costul muchiilor 

void CitesteGraf();
void CicluHamiltCostMin();

int main()
{
    CitesteGraf();
    CicluHamiltCostMin();
 
    return 0;
}

void CicluHamiltCostMin()
{
	for (int i = 0; i < (1 << n); ++i)
        for (int j = 0; j < n; ++j) 
			C[i][j] = INF;
 
    C[1][0] = 0; // masca 1 contine numai nodul 0
 
    for (int i = 0; i < (1 << n); ++i)
        for (int k = 0; k < n; ++k)       // k si j sunt in submultimea i
            if (i & (1 << k))
                for (const int& j : G[k]) // updatam starea cu submultimea i care-l include pe j
                    if (i & (1 << j))     // cu starea  i ^ (1 << j) care nu-l include pe j si lantul se termina cu k
                        C[i][j] = min(C[i][j], C[i ^ (1 << j)][k] + w[k][j]); 
 
    res = INF;
    // consider 0 nodul de plecare
	int res = INF;
    for (int j = 0; j < n; ++j)
		res = min(res, C[(1 << n) - 1][j] + w[j][0]); 
 
    if (res == INF) 
		fout << "Nu exista solutie\n";
    else 
		fout << res << '\n';
}

void CitesteGraf()
{
	fin >> n >> m;
	
    for (int x = 0; x < n; ++x)
		for (int y = 0; y < n; ++y)
			w[x][y] = INF;
	int x, y, cost;
	
	for (int i = 0; i < m; ++i)
	{
		fin >> x >> y >> cost;
		G[x].push_back(y);
		w[x][y] = cost;
	}
}
