#include <fstream>
#include <vector>
#include <queue>
using namespace std;

ifstream fin("cartite.in");
ofstream fout("cartite.out");
int task, n, m, ic, jc, k, r, a[201][201];
const int dx[]={-1, 0, 1, 0, -1, 1, 1, -1},
	      dy[]={0, 1, 0, -1, 1, 1, -1, -1};
	      
bool viz[110];
vector<pair<int,int>>v[200202];
vector<int>sol;
bool Inside(int l,int c)
{
    return l > 0 && l <= n && c > 0 && c <= m;
}

queue<int>q;

void Lee()
{
    int d = 0, is, js;
    if(a[ic][jc] == -2)
        is = ic, js = jc;
	else
	{
    	a[ic][jc] = 1;
    	q.push(ic * 1000 + jc);
	}
    while (!q.empty() && d == 0)
    {
        int l = q.front() / 1000, c = q.front() % 1000;
        q.pop();
        for (int i = 0; i < 4; ++i)
        {
            int lv = l + dx[i], cv = c + dy[i];
            if (Inside(lv, cv))
            {
                if (a[lv][cv] == 0)
                {
                    q.push(lv * 1000 + cv);
                    a[lv][cv] = a[l][c] + 1;
                }
                else 
                if (a[lv][cv] == -2)
                {
                    d = a[l][c], is = lv, js = cv;
                    break;
                }
			}
        }
    }
    
    fout << is << " " << js << " " << d;
}

void Euler(int nod)
{
    while(!v[nod].empty())
    {
        int k = v[nod].back().first, ind = v[nod].back().second;
        v[nod].pop_back();
        if(!viz[ind])
        {
            viz[ind] = 1;
            Euler(k);
        }
    }
    sol.push_back(nod);
}

int main()
{
    fin >> task >> n >> m >> ic >> jc >> k;
    int i1, j1, i2, j2;
    while (k--)
    {
        fin >> i1 >> j1 >> r;
        a[i1][j1] = -1;
        for (int i = 1; i <= r; ++i)
            for (int j = 0; j < 4; ++j)
            {
                int l = i1 + dx[j] * i, c = j1 + dy[j] * i;
                if (Inside(l, c))
                    a[l][c] = -1;
            }
            
        if (r == 2)
            for (int i = 4; i < 8; ++i)
            {
                int l = i1 + dx[i], c = j1 + dy[i];
                if (Inside(l, c))
                    a[l][c] = -1;
            }
    }
    fin >> k;
    for (int i = 1; i <= k; ++i)
    {
        fin >> i1 >> j1 >> i2 >> j2;
        if (a[i1][j1] != -1)
            a[i1][j1] = -2;
        if(a[i2][j2] != -1)
            a[i2][j2] = -2;
        v[i1 * 1000 + j1].push_back({i2 * 1000 + j2, i});
        v[i2 * 1000 + j2].push_back({i1 * 1000 + j1, i});
    }
    
    if (task == 1)
        Lee();
    else
    {
        Euler(i1 * 1000 + j1);
        for(auto i: sol)
            fout << i / 1000 << " " << i % 1000 << '\n';
    }
    return 0;
}
